Subject: Re: [PATCH 00/25] [RFC] Bundle URIs

From: Derrick Stolee <[email-masked]>
Date: Fri, 4 Mar 2022 08:30:29 -0500

On 2/24/2022 9:11 AM, Derrick Stolee wrote:
> On 2/23/2022 5:17 PM, Ævar Arnfjörð Bjarmason wrote:
>>
>> On Wed, Feb 23 2022, Derrick Stolee via GitGitGadget wrote:

>>> There have been several suggestions to improve Git clone speeds and
>>> reliability by supplementing the Git protocol with static content. The
>>> Packfile URI [0] feature lets the Git response include URIs that point to
>>> packfiles that the client must download to complete the request.
>>>
>>> Last year, Ævar suggested using bundles instead of packfiles [1] [2]. This
>>> design has the same benefits to the packfile URI feature because it offloads
>>> most object downloads to static content fetches. The main advantage over
>>> packfile URIs is that the remote Git server does not need to know what is in
>>> those bundles. The Git client tells the server what it downloaded during the
>>> fetch negotiation afterwards. This includes any chance that the client did
>>> not have access to those bundles or otherwise failed to access them. I
>>> agreed that this was a much more desirable way to serve static content, but
>>> had concerns about the flexibility of that design [3]. I have not heard more
>>> on the topic since October, so I started investigating this idea myself in
>>> December, resulting in this RFC.
>>
>> This timing is both quite fortunate & unfortunate for me, since I'd been
>> blocked / waiting on various things until very recently to submit a
>> non-RFC re-roll of (a larger version of) that series you mentioned from
>> October.
>>
>> I guess the good news is that we'll have at least one guaranteed very
>> interested reviewer for each other's patches, and that the design that
>> makes it into git.git in the end will definitely be well hashed out :)
>>
>> I won't be able to review this in any detail right at this hour, but
>> will be doing so. I'd also like to submit what I've got in some form
>> soon for hashing the two out.
>>
>> It will be some 50+ patches on the ML in total though related to this
>> topic, so I think the two of us coming up with some way to manage all of
>> that for both ourselves & others would be nice. Perhaps we could also
>> have an off-list (video) chat in real time to clarify/discuss various
>> thing related to this.
> 
> I look forward to seeing your full implementation. There are many things
> about your RFC that left me confused and not fully understanding your
> vision.

I am genuinely curious to see your full implementation of bundle URIs.
I've been having trouble joining the Git IRC chats, but I saw from the
logs that you are working on getting patches together.

Do you have an expected timeline on that progress?

I would like to move forward in getting bundle URIs submitted as a full
feature, but it is important to see your intended design so we can take
the best parts of both to create a version that satisfies us both.

Thanks,
-Stolee